Handle RC and milestone calver comparison. (#320)

This commit is contained in:
Olga Maciaszek-Sharma
2024-12-03 17:00:21 +01:00
committed by GitHub
parent 5a44b81974
commit 28ac233277
43 changed files with 782 additions and 758 deletions

View File

@@ -1,5 +1,5 @@
/*
* Copyright 2013-2019 the original author or authors.
* Copyright 2013-2024 the original author or authors.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
@@ -46,6 +46,7 @@ enum ReleaseType {
* version;
*
* @author Marcin Grzejszczak
* @author Olga Maciaszek-Sharma
*/
public class ProjectVersion implements Comparable<ProjectVersion>, Serializable {
@@ -823,6 +824,10 @@ public class ProjectVersion implements Comparable<ProjectVersion>, Serializable
public int compareTo(TrainVersionNumber o) {
ProjectVersion thisVersion = this.version;
ProjectVersion thatVersion = o.version;
// "" vs ""
if (!thatVersion.isValid() && !thisVersion.isValid()) {
return 0;
}
// 2020.0.0 vs ""
if (!thatVersion.isValid() && thisVersion.isValid()) {
return 1;
@@ -842,6 +847,9 @@ public class ProjectVersion implements Comparable<ProjectVersion>, Serializable
else if (thatOldTrain) {
return -1 * compareWithOldTrain(thisVersion, thatVersion);
}
if (thisVersion.major().equals(thatVersion.major())) {
return calVerSuffixComparison(thatVersion);
}
// new train comparison
return thisVersion.compareTo(thatVersion);
}
@@ -896,6 +904,20 @@ public class ProjectVersion implements Comparable<ProjectVersion>, Serializable
return thisNumber.compareTo(thatNumber);
}
private int calVerSuffixComparison(ProjectVersion thatVersion) {
// With calVer if this project version doesn't have suffix,
// and the other has suffix, but is not snapshot is when this project version
// is a GA
// and the other project version is a milestone or RC
if (this.version.assertVersion().suffix.isEmpty()) {
if (!(thatVersion.assertVersion().suffix.isEmpty() || thatVersion.isSnapshot())) {
return 1;
}
}
return this.version.compareTo(thatVersion);
}
}
}

View File

@@ -37,7 +37,7 @@ public class ReleaseTrainContentsParserTests {
public void should_retrieve_latest_release_version_name() {
String releaseTrain = new ReleaseTrainContentsParser().latestReleaseTrainFromWiki(this.finchley);
BDDAssertions.then(releaseTrain).isEqualTo("Finchley.SR2");
BDDAssertions.then(releaseTrain).isEqualTo("Finchley.SR4");
}
}

View File

@@ -1,5 +1,5 @@
/*
* Copyright 2013-2022 the original author or authors.
* Copyright 2013-2024 the original author or authors.
*
* Licensed under the Apache License, Version 2.0 (the "License");
* you may not use this file except in compliance with the License.
@@ -41,6 +41,7 @@ import org.springframework.util.FileSystemUtils;
/**
* @author Marcin Grzejszczak
* @author Olga Maciaszek-Sharma
*/
public class ReleaseTrainContentsUpdaterTests {
@@ -129,6 +130,22 @@ public class ReleaseTrainContentsUpdaterTests {
.contains("Updating project page to release train [Edgware.SR7]");
}
@Test
public void should_update_the_contents_of_wiki_on_GA_when_previous_release_RC()
throws GitAPIException, IOException {
this.properties.getMetaRelease().setEnabled(true);
this.properties.getGit().setUpdateReleaseTrainWiki(true);
this.properties.getGit().setReleaseTrainWikiUrl(this.wikiRepo.getAbsolutePath() + "/");
File file = this.updater.updateReleaseTrainWiki(newGACalver());
BDDAssertions.then(file).isNotNull();
BDDAssertions.then(calverWithRCWikiEntryContent(file)).contains("# 2024.0.0").contains(
"Spring Cloud Consul `4.2.0` ([issues](https://github.com/spring-cloud/spring-cloud-consul/releases/tag/v4.2.0))");
BDDAssertions.then(GitTestUtils.openGitProject(file).log().call().iterator().next().getShortMessage())
.contains("Updating project page to release train [2024.0.0]");
}
@Test
public void should_generate_the_contents_of_wiki_when_release_train_missing() throws GitAPIException, IOException {
this.properties.getMetaRelease().setEnabled(true);
@@ -172,6 +189,10 @@ public class ReleaseTrainContentsUpdaterTests {
return string(file, "Spring-Cloud-2020.0-Release-Notes.md");
}
private String calverWithRCWikiEntryContent(File file) throws IOException {
return string(file, "Spring-Cloud-2024.0-Release-Notes.md");
}
private String string(File file, String s) throws IOException {
return new String(Files.readAllBytes(new File(file, s).toPath()));
}
@@ -272,4 +293,22 @@ public class ReleaseTrainContentsUpdaterTests {
new ProjectVersion("spring-cloud-function", "1.0.0.RELEASE"));
}
Projects newGACalver() {
return new Projects(new ProjectVersion("spring-cloud-bus", "4.2.0"),
new ProjectVersion("spring-cloud-commons", "4.2.0"),
new ProjectVersion("spring-cloud-contract", "4.2.0"),
new ProjectVersion("spring-cloud-config", "4.2.0"), new ProjectVersion("spring-cloud-consul", "4.2.0"),
new ProjectVersion("spring-cloud-netflix", "4.2.0"), new ProjectVersion("spring-cloud-consul", "4.2.0"),
new ProjectVersion("spring-cloud-stream", "4.2.0"),
new ProjectVersion("spring-cloud-zookeeper", "4.2.0"), new ProjectVersion("spring-boot", "3.4.0"),
new ProjectVersion("spring-cloud-task", "3.2.0"),
// newer release train, current version in file is 2024.0.0-RC1
new ProjectVersion("spring-cloud-release", "2024.0.0"),
new ProjectVersion("spring-cloud-vault", "4.2.0"), new ProjectVersion("spring-cloud-gateway", "4.2.0"),
new ProjectVersion("spring-cloud-openfeign", "4.2.0"),
new ProjectVersion("spring-cloud-circuitbreaker", "3.2.0"),
new ProjectVersion("spring-cloud-kubernetes", "3.2.0"),
new ProjectVersion("spring-cloud-function", "4.2.0"));
}
}

View File

@@ -1,12 +1,28 @@
Spring Cloud provides tools for developers to quickly build some of the common patterns in distributed systems (e.g. configuration management, service discovery, circuit breakers, intelligent routing, micro-proxy, control bus, one-time tokens, global locks, leadership election, distributed sessions, cluster state).
Coordination of distributed systems leads to boiler plate patterns, and using Spring Cloud developers can quickly stand up services and applications that implement those patterns.
They will work well in any distributed environment, including the developer's own laptop, bare metal data centres, and managed platforms such as Cloud Foundry.
# NOTICE
This wiki is no longer updated and is here for historical purposes.
Please see
https://github.com/spring-cloud/spring-cloud-release/wiki for up to date information.
---
Spring Cloud provides tools for developers to quickly build some of
the common patterns in distributed systems (e.g. configuration
management, service discovery, circuit breakers, intelligent routing,
micro-proxy, control bus, one-time tokens, global locks, leadership
election, distributed sessions, cluster state). Coordination of
distributed systems leads to boiler plate patterns, and using Spring
Cloud developers can quickly stand up services and applications that
implement those patterns. They will work well in any distributed
environment, including the developer's own laptop, bare metal data
centres, and managed platforms such as Cloud Foundry.
See https://projects.spring.io/spring-cloud[projects.spring.io/spring-cloud] for details.
== Release Notes
See the following release notes for upgrade instructions and "new and noteworthy" features:
See the following release notes for upgrade instructions and "new and noteworthy" features (newer release trains at the end):
- link:Spring-Cloud-Angel-Release-Notes[Angel]
@@ -18,4 +34,10 @@ See the following release notes for upgrade instructions and "new and noteworthy
- link:Spring-Cloud-Edgware-Release-Notes[Edgware]
- link:Spring-Cloud-Finchley-Release-Notes[Finchley]
- link:Spring-Cloud-Finchley-Release-Notes[Finchley]
- link:Spring-Cloud-Greenwich-Release-Notes[Greenwich]
- link:https://github.com/spring-cloud/spring-cloud-release/wiki/Spring-Cloud-Hoxton-Release-Notes[Hoxton]
- link:https://github.com/spring-cloud/spring-cloud-release/wiki/Spring-Cloud-2020.0-Release-Notes[2020.0 (code name ilford)]

View File

@@ -1,539 +1 @@
# 2020.0.4
[All Issues](https://github.com/orgs/spring-cloud/projects/64)
2021-09-22
- Spring Cloud Cloudfoundry `3.0.2`
- Spring Cloud Config `3.0.5`
- Spring Cloud Contract `3.0.4`
- Spring Cloud Consul `3.0.4`
- Spring Cloud Gateway `3.0.4`
- Spring Cloud Netflix `3.0.4`
- Spring Cloud Vault `3.0.4`
- Spring Cloud Kubernetes `2.0.4`
- Spring Cloud Circuitbreaker `2.0.2`
- Spring Cloud Bus `3.0.3`
- Spring Cloud Cli `3.0.3`
- Spring Cloud Zookeeper `3.0.4`
- Spring Cloud Sleuth `3.0.4`
- Spring Cloud Starter Build `2020.0.4`
- Spring Cloud Task `2.3.2`
- Spring Cloud Commons `3.0.4`
- Spring Cloud Openfeign `3.0.4`
# 2020.0.3
## Breaking changes
Actuator is no longer a required dependency of config server [1742](https://github.com/spring-cloud/spring-cloud-config/issues/1742)
[All Issues](https://github.com/orgs/spring-cloud/projects/61)
2021-05-28
- Spring Cloud Cloudfoundry `3.0.2`
- Spring Cloud Config `3.0.4` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/89?closed=1))
- Spring Cloud Contract `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/77?closed=1))
- Spring Cloud Consul `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/57?closed=1))
- Spring Cloud Gateway `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/51?closed=1))
- Spring Cloud Netflix `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/102?closed=1))
- Spring Cloud Vault `3.0.3`
- Spring Cloud Kubernetes `2.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/31?closed=1))
- Spring Cloud Circuitbreaker `2.0.2`
- Spring Cloud Bus `3.0.3`
- Spring Cloud Cli `3.0.3`
- Spring Cloud Zookeeper `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/37?closed=1))
- Spring Cloud Sleuth `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/90?closed=1))
- Spring Cloud Starter Build `2020.0.3`
- Spring Cloud Task `2.3.2`
- Spring Cloud Commons `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/89?closed=1))
- Spring Cloud Openfeign `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/36?closed=1))
This release makes it possible for all projects except for Spring Cloud Contract to use Spring Boot 2.5. Spring Boot 2.5 includes a major update of Groovy that can lead to various issues while using Spring Cloud Contract.
# 2020.0.2
[All Issues](https://github.com/orgs/spring-cloud/projects/53)
2021-03-17
- Spring Cloud Cloudfoundry `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-cloudfoundry/milestone/16?closed=1))
- Spring Cloud Commons `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/87?closed=1))
- Spring Cloud Config `3.0.3` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/88?closed=1))
- Spring Cloud Contract `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/75?closed=1))
- Spring Cloud Consul `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/56?closed=1))
- Spring Cloud Gateway `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/49?closed=1))
- Spring Cloud Netflix `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/100?closed=1))
- Spring Cloud Circuitbreaker `2.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/milestone/8?closed=1))
- Spring Cloud Zookeeper `3.0.2`
- Spring Cloud Kubernetes `2.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/30?closed=1))
- Spring Cloud Vault `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/47?closed=1))
- Spring Cloud Task `2.3.1`
- Spring Cloud Sleuth `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/88?closed=1))
- Spring Cloud Bus `3.0.2`
- Spring Cloud Cli `3.0.2`
- Spring Cloud Starter Build `2020.0.2`
- Spring Cloud Openfeign `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/34?closed=1))
# 2020.0.1
[All Issues](https://github.com/orgs/spring-cloud/projects/52)
2021-01-27
- Spring Cloud Openfeign `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/33?closed=1))
- Spring Cloud Config `3.0.2` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/87?closed=1))
- Spring Cloud Commons `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/86?closed=1))
- Spring Cloud Contract `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/74?closed=1))
- Spring Cloud Consul `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/54?closed=1))
- Spring Cloud Gateway `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/48?closed=1))
- Spring Cloud Netflix `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/99?closed=1))
- Spring Cloud Zookeeper `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/34?closed=1))
- Spring Cloud Vault `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/46?closed=1))
- Spring Cloud Kubernetes `2.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/29?closed=1))
- Spring Cloud Sleuth `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/87?closed=1))
- Spring Cloud Bus `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-bus/milestone/47?closed=1))
- Spring Cloud Cli `3.0.1` ([issues](https://github.com/spring-cloud/spring-cloud-cli/milestone/24?closed=1))
- Spring Cloud Starter Build `2020.0.1`
# 2020.0.0
## Known Issues
- 2020.0.0 Spring Cloud Consul: Retry support has not been added yet using `spring.config.import=consul:`. Follow the [issue here](https://github.com/spring-cloud/spring-cloud-consul/issues/703). The workaround is to use the old bootstrap style by including `spring-cloud-starter-bootstrap`.
Spring Cloud Config [3.0.1](https://github.com/spring-cloud/spring-cloud-config/milestone/85?closed=1) has been released to fix the issues below. Please use version 2020.0.1 which includes all the fixes below.
- 2020.0.0 Spring Cloud Config: Retry support is missing for `spring.config.import=configserver:`. Follow the issue [here](github.com/spring-cloud/spring-cloud-config/issues/1775). For a workaround, continue to use `bootstrap.{yml|properties}` and add a dependency on `spring-cloud-starter-bootstrap` to restore the old behavior.
- 2020.0.0 Spring Cloud Config: spring-cloud-config-dependencies imports a milestone of spring-vault. Follow the issue [here](github.com/spring-cloud/spring-cloud-config/issues/1776). See [a workaround here](https://github.com/spring-cloud/spring-cloud-config/issues/1776#issuecomment-749782456)
- 2020.0.0 Spring Cloud Config: using `spring.config.import` value of `spring.profiles.active` not being used. Follow the issue and see workarounds [here](https://github.com/spring-cloud/spring-cloud-config/issues/1777).
- 2020.0.0 Spring Cloud Config: Multi-document YAML and properties files from config server have the same property source name which leads to a missing property source. Follow the issue [here](https://github.com/spring-cloud/spring-cloud-config/issues/1778).
## Breaking changes
- As [announced](https://spring.io/blog/2019/12/23/spring-cloud-roadmap-and-hoxton-and-greenwich-maintenance-and-eol-announcements), the following modules have been removed from spring-cloud-netflix:
- spring-cloud-netflix-archaius
- spring-cloud-netflix-concurrency-limits
- spring-cloud-netflix-core
- spring-cloud-netflix-dependencies
- spring-cloud-netflix-hystrix
- spring-cloud-netflix-hystrix-contract
- spring-cloud-netflix-hystrix-dashboard
- spring-cloud-netflix-hystrix-stream
- spring-cloud-netflix-ribbon
- spring-cloud-netflix-sidecar
- spring-cloud-netflix-turbine
- spring-cloud-netflix-turbine-stream
- spring-cloud-netflix-zuul
- spring-cloud-starter-netflix-archaius
- spring-cloud-starter-netflix-hystrix
- spring-cloud-starter-netflix-hystrix-dashboard
- spring-cloud-starter-netflix-ribbon
- spring-cloud-starter-netflix-turbine
- spring-cloud-starter-netflix-turbine-stream
- spring-cloud-starter-netflix-zuul
- Support for ribbon, hystrix and zuul was removed across the release train projects.
- Bootstrap, provided by spring-cloud-commons, is no longer enabled by default. If your project requires it, it can be re-enabled by properties or by a new starter.
- To re-enable by properties set `spring.cloud.bootstrap.enabled=true` or `spring.config.use-legacy-processing=true`. These need to be set as an environment variable, java system property or a command line argument.
- The other option is to include the new `spring-cloud-starter-bootstrap`.
- Support has been added for the new Spring Boot `spring.config.import` syntax for Config Server, Consul, Zookeeper and Vault. The existing properties to configure the different services are still supported but need to be put in `application.properties` or `application.yml`.
- `spring.config.import=configserver:`
- `spring.config.import=consul:`
- `spring.config.import=zookeeper:`
- `spring.config.import=vault:`
- Spring Cloud Consul removed the old tags-as-metadata functionality [issue](https://github.com/spring-cloud/spring-cloud-consul/issues/630)
- Previously the property to disable the Spring Cloud Config Client Health Indicator was `health.config.enabled=false`. It is now `management.health.config.enabled=false` following the Spring Boot convention.
- Spring Cloud Security was removed and code was moved to the individual Spring Cloud projects.
- The `spring-cloud-gateway-core` module was moved to `spring-cloud-gateway-server`. If you are using `spring-cloud-gateway-starter` this will not be an issue.
- The implementation of spring-cloud-bus was migrated to use spring-cloud-function instead of the legacy annotation-driven model. This should have minimal effect on users.
- `spring-cloud-stream` is now an optional dependency of `spring-cloud-bus`. If you are using a binder other than rabbitmq or kafka you will need to inclue the new `spring-cloud-starter-bus-stream`.
- Actuator endpoints with invalid characters (dashes) have been updated to remove them:
- `bus-env` is now `busenv`
- `bus-refresh` is now `busrefresh`
- `service-registry` is now `serviceregistry`
- In Spring Cloud Config, the endpoints from the resource API that used the `useDefaultLabel` query parameter have [been removed](https://github.com/spring-cloud/spring-cloud-config/issues/1643).
- As [announced](https://spring.io/blog/2020/04/17/spring-cloud-2020-0-0-m1-released) Spring Cloud GCP is no longer part of the Spring Cloud release train
### Spring Cloud Kubernetes
#### Code Refactoring
* Code that was not dependent on any Kubernetes client was moved into a module name `spring-cloud-kubernetes-commons`
* Packages were renamed to be Fabric8 specific. Any package that began with `org.springframework.cloud.kubernetes` has been renamed too `org.springframework.cloud.kubernetes.fabric8`
#### Kubernetes Client Implementations
* There are alternate implementations for much of the functionality in Spring Cloud Kubernetes using the [Kubernetes Java Client](https://github.com/kubernetes-client/java).
| Functionality | Starter |
| ---------------- | --------------- |
| Kubernetes Detection | spring-cloud-kubernetes-client |
| Configuration | spring-cloud-starter-kubernetes-client-config |
| Loadbalancer | spring-cloud-starter-kubernetes-client-loadbalancer |
| Discovery | spring-cloud-starter-kubernetes-client-all |
NOTE: When using the new Informer based DiscoveryClient you must give cluster wide permissions to the app due to [a bug in the Kubernetes Java Client](https://github.com/kubernetes-client/java/pull/1409)
#### Configuration Change Listener
* Classes related to event based and polling configuration change listeners have now been split up [PR 644](https://github.com/spring-cloud/spring-cloud-kubernetes/pull/644)
#### Renamed Starters
| Old Starter | Renamed Starter |
| ---------------- | --------------- |
| spring-cloud-starter-kubernetes | spring-cloud-starter-kubernetes-fabric8 |
| spring-cloud-starter-kubernetes-config | spring-cloud-starter-kubernetes-fabric8-config |
| spring-cloud-starter-kubernetes-all | spring-cloud-starter-kubernetes-fabric8-all |
| spring-cloud-starter-kubernetes-loadbalancer | spring-cloud-starter-kubernetes-fabric8-loadbalancer |
### Spring Cloud Sleuth
Most notable breaking changes:
#### `3.0.0-RC1`
##### Moving OpenTelemetry support to incubator
OpenTelemetry was unable to provide a reliable GA date of their modules. We've decided to remove OpenTelemetry support from Spring Cloud Sleuth and move it to incubator https://github.com/spring-cloud-incubator/spring-cloud-sleuth-otel/ . If you want to continue using OpenTelemetry with Spring Cloud Sleuth you need to add the Spring repositories, the `spring-cloud-sleuth-otel-dependencies` BOM and `spring-cloud-sleuth-otel-autoconfigure` dependency.
We have released a `1.0.0-M1` of Spring Cloud Sleuth OTel that is compatible with the `2020.0.0-RC1` release train.
.Maven
```xml
<properties>
<spring-cloud-sleuth-otel.version>1.0.0-M1</spring-cloud-sleuth-otel.version>
</properties>
<dependencyManagement>
<dependencies>
<dependency>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-dependencies</artifactId>
<!-- Provide the latest stable Spring Cloud release train version (e.g. 2020.0.0) -->
<version>${release.train.version}</version>
<type>pom</type>
<scope>import</scope>
</dependency>
<dependency>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-sleuth-otel-dependencies</artifactId>
<!-- Provide the version of the Spring Cloud Sleuth OpenTelemetry project -->
<version>${spring-cloud-sleuth-otel.version}</version>
<scope>import</scope>
<type>pom</type>
</dependency>
</dependencies>
</dependencyManagement>
<dependency>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-starter-sleuth</artifactId>
<exclusions>
<exclusion>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-sleuth-brave</artifactId>
</exclusion>
</exclusions>
</dependency>
<dependency>
<groupId>org.springframework.cloud</groupId>
<artifactId>spring-cloud-sleuth-otel-autoconfigure</artifactId>
</dependency>
<!-- You 'll need those to add OTel support -->
<repositories>
<repository>
<id>spring-snapshots</id>
<url>https://repo.spring.io/snapshot</url>
<snapshots><enabled>true</enabled></snapshots>
</repository>
<repository>
<id>spring-milestones</id>
<url>https://repo.spring.io/milestone</url>
</repository>
</repositories>
<pluginRepositories>
<pluginRepository>
<id>spring-snapshots</id>
<url>https://repo.spring.io/snapshot</url>
</pluginRepository>
<pluginRepository>
<id>spring-milestones</id>
<url>https://repo.spring.io/milestone</url>
</pluginRepository>
</pluginRepositories>
```
.Gradle
```
ext {
springCloudSleuthOtelVersion = "1.0.0-M1"
}
dependencyManagement {
imports {
mavenBom "org.springframework.cloud:spring-cloud-dependencies:${releaseTrainVersion}"
mavenBom "org.springframework.cloud:spring-cloud-sleuth-otel-dependencies:${springCloudSleuthOtelVersion}"
}
}
dependencies {
implementation("org.springframework.cloud:spring-cloud-starter-sleuth") {
exclude group: 'org.springframework.cloud', module: 'spring-cloud-sleuth-brave'
}
implementation "org.springframework.cloud:spring-cloud-sleuth-otel-autoconfigure"
}
repositories {
mavenCentral()
maven {
url "https://repo.spring.io/snapshot"
}
maven {
url "https://repo.spring.io/milestone"
}
maven {
url "https://repo.spring.io/release"
}
}
```
#### `3.0.0-M6`
##### Modules
* New modules: `spring-cloud-sleuth-autoconfigure`, `spring-cloud-sleuth-api`, `spring-cloud-sleuth-instrumentation`
`spring-cloud-sleuth-core` removed and changed to `spring-cloud-sleuth-instrumentation` & `spring-cloud-sleuth-api`
* Removed `spring-cloud-starter-sleuth-otel`
To add OpenTelemetry support you need to add `spring-cloud-starter-sleuth` (adds Brave by default), exclude Brave and add `spring-cloud-sleuth-otel` dependency
* Except for the tests, `spring-cloud-sleuth-autoconfigure` is the only module that can have access to `@Configuration`, `@ConfiguraationProperties` classes.
Tests have been added to ensure such separation.
##### Package moving
* `org.springframework.cloud.sleuth.api` -> `org.springframework.cloud.sleuth`
* `org.springframework.cloud.sleuth.brave.autoconfig` -> `org.springframework.cloud.sleuth.autoconfig.brave`
* `org.springframework.cloud.sleuth.otel.autoconfig` -> `org.springframework.cloud.sleuth.autoconfig.otel`
* `org.springframework.cloud.sleuth` -> `org.springframework.cloud.sleuth`
* Instrumentation: `org.springframework.cloud.sleuth.annotation` -> `org.springframework.cloud.sleuth.instrument.annotation`
* All the autoconfiguration classes were moved under `org.springframework.cloud/sleuth.autoconfig` package
##### Global class modifications
* Any class registered as a bean is now public
##### Classes
* `RateLimitingSampler` constructor changed
* Merged a lot of auto configuration classes into one (e.g. `BraveAutoConfiguration` now imports various other configurations)
* Renamed `TraceBraveAutoConfiguration` to `BraveAutoConfiguration`
* Renamed `TraceOtelAutoConfiguration` to `OtelAutoConfiguration`
* Removed all `NoOp` implementations of the API
To see the whole list check [this Github page](https://github.com/spring-cloud/spring-cloud-sleuth/issues?q=label%3A%22breaking+change%22+is%3Aclosed) and search for `3.0.0` milestones.
You can also check the [Sleuth 3.0.0 migration guide](https://github.com/spring-cloud/spring-cloud-sleuth/wiki/Spring-Cloud-Sleuth-3.0-Migration-Guide).
#### Up till `3.0.0-M5`
* Introduces abstraction over tracers [PR 1757](https://github.com/spring-cloud/spring-cloud-sleuth/pull/1757)
* You can use Spring Cloud Sleuth's abstraction over Span's lifecycle [Check the docs](https://docs.spring.io/spring-cloud-sleuth/docs/3.0.x-SNAPSHOT/reference/html/using.html#using)
* You can use Brave or OpenTelemetry directly
* Module change / removal
* Point of entry should be `spring-cloud-starter-sleuth` (Brave support) or `spring-cloud-starter-otel` (OpenTelemetry support).
* If you want to use Zipkin: `spring-cloud-starter-zipkin` is removed and you should replace is with `spring-cloud-sleuth-zipkin` dependency.
* Enable reactor manual instrumentation when in gateway breaking change enhancement [Issue 1710](https://github.com/spring-cloud/spring-cloud-sleuth/issues/1710)
* Remove the legacy Sleuth keys, span naming breaking change [Issue 1564](https://github.com/spring-cloud/spring-cloud-sleuth/issues/1564)
* Remove the legacy MDC entries and remain with the Brave MDC ones only breaking change enhancement [Issue 1221](https://github.com/spring-cloud/spring-cloud-sleuth/issues/1221)
# 2020.0.0-RC1
[All Issues](https://github.com/orgs/spring-cloud/projects/50)
2020-12-11
- Spring Cloud Circuitbreaker `2.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/milestone/7?closed=1))
- Spring Cloud Contract `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/73?closed=1))
- Spring Cloud Kubernetes `2.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/27?closed=1))
- Spring Cloud Commons `3.0.0-RC1`
- Spring Cloud Openfeign `3.0.0-RC1`
- Spring Cloud Cloudfoundry `3.0.0-RC1`
- Spring Cloud Security `3.0.0-RC1`
- Spring Cloud Bus `3.0.0-RC1`
- Spring Cloud Cli `3.0.0-RC1`
- Spring Cloud Zookeeper `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/32?closed=1))
- Spring Cloud Sleuth `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/85?closed=1))
- Spring Cloud Consul `3.0.0-RC1`
- Spring Cloud Starter Build `2020.0.0-RC1`
- Spring Cloud Gateway `3.0.0-RC1`
- Spring Cloud Netflix `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/97?closed=1))
- Spring Cloud Vault `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/43?closed=1))
- Spring Cloud Config `3.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/83?closed=1))
# 2020.0.0-M6
[All Issues](https://github.com/orgs/spring-cloud/projects/49)
2020-12-01
- Spring Cloud Sleuth `3.0.0-M6` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/84?closed=1))
- Spring Cloud Consul `3.0.0-M6`
- Spring Cloud Gateway `3.0.0-M6`
- Spring Cloud Zookeeper `3.0.0-M6`
- Spring Cloud Config `3.0.0-M6`
- Spring Cloud Cloudfoundry `3.0.0-M6`
- Spring Cloud Netflix `3.0.0-M6`
- Spring Cloud Kubernetes `2.0.0-M6`
- Spring Cloud Circuitbreaker `2.0.0-M6`
- Spring Cloud Contract `3.0.0-M6` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/72?closed=1))
- Spring Cloud Starter Build `2020.0.0-M6`
- Spring Cloud Security `3.0.0-M6`
- Spring Cloud Bus `3.0.0-M6`
- Spring Cloud Cli `3.0.0-M6`
- Spring Cloud Vault `3.0.0-M6`
- Spring Cloud Openfeign `3.0.0-M6`
- Spring Cloud Commons `3.0.0-M6`
# 2020.0.0-M5
[All Issues](https://github.com/orgs/spring-cloud/projects/46)
2020-11-17
- Spring Cloud Consul `3.0.0-M5`
- Spring Cloud Gateway `3.0.0-M5`
- Spring Cloud Zookeeper `3.0.0-M5`
- Spring Cloud Sleuth `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/81?closed=1))
- Spring Cloud Cloudfoundry `3.0.0-M5`
- Spring Cloud Config `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/82?closed=1))
- Spring Cloud Kubernetes `2.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/24?closed=1))
- Spring Cloud Netflix `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/95?closed=1))
- Spring Cloud Starter Build `2020.0.0-M5`
- Spring Cloud Circuitbreaker `2.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/milestone/6?closed=1))
- Spring Cloud Contract `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/70?closed=1))
- Spring Cloud Security `3.0.0-M5`
- Spring Cloud Bus `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-bus/milestone/46?closed=1))
- Spring Cloud Cli `3.0.0-M5`
- Spring Cloud Openfeign `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/30?closed=1))
- Spring Cloud Vault `3.0.0-M5`
- Spring Cloud Commons `3.0.0-M5` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/80?closed=1))
# 2020.0.0-M4
[All Issues](https://github.com/orgs/spring-cloud/projects/43)
2020-10-05
- Spring Cloud Sleuth `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/79?closed=1))
- Spring Cloud Consul `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/51?closed=1))
- Spring Cloud Config `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/80?closed=1))
- Spring Cloud Kubernetes `2.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/milestone/21?closed=1))
- Spring Cloud Gateway `3.0.0-M4`
- Spring Cloud Circuitbreaker `2.0.0-M4`
- Spring Cloud Contract `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/68?closed=1))
- Spring Cloud Starter Build `2020.0.0-M4`
- Spring Cloud Netflix `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/92?closed=1))
- Spring Cloud Cloudfoundry `3.0.0-M4`
- Spring Cloud Security `3.0.0-M4`
- Spring Cloud Cli `3.0.0-M4`
- Spring Cloud Bus `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-bus/milestone/45?closed=1))
- Spring Cloud Zookeeper `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/31?closed=1))
- Spring Cloud Commons `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/77?closed=1))
- Spring Cloud Openfeign `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/25?closed=1))
- Spring Cloud Vault `3.0.0-M4` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/42?closed=1))
# 2020.0.0-M3
[All Issues](https://github.com/orgs/spring-cloud/projects/42)
2020-07-23
- Spring Cloud Sleuth `3.0.0-M3`
- Spring Cloud Kubernetes `2.0.0-M3`
- Spring Cloud Consul `3.0.0-M3`
- Spring Cloud Config `3.0.0-M3` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/77?closed=1))
- Spring Cloud Gateway `3.0.0-M3`
- Spring Cloud Starter Build `2020.0.0-M3`
- Spring Cloud Circuitbreaker `2.0.0-M3`
- Spring Cloud Contract `3.0.0-M3` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/67?closed=1))
- Spring Cloud Cloudfoundry `3.0.0-M3`
- Spring Cloud Security `3.0.0-M3`
- Spring Cloud Netflix `3.0.0-M3`
- Spring Cloud Cli `3.0.0-M3`
- Spring Cloud Bus `3.0.0-M3`
- Spring Cloud Zookeeper `3.0.0-M3`
- Spring Cloud Commons `3.0.0-M3`
- Spring Cloud Vault `3.0.0-M3`
- Spring Cloud Openfeign `3.0.0-M3`
# 2020.0.0-M2
[All Issues](https://github.com/orgs/spring-cloud/projects/39)
2020-05-29
- Spring Cloud Netflix `3.0.0-M2`
- Spring Cloud Sleuth `3.0.0-M2`
- Spring Cloud Consul `3.0.0-M2`
- Spring Cloud Kubernetes `2.0.0-M2`
- Spring Cloud Gateway `3.0.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/38?closed=1))
- Spring Cloud Circuitbreaker `2.0.0-M2`
- Spring Cloud Contract `3.0.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/65?closed=1))
- Spring Cloud Starter Build `2020.0.0-M2`
- Spring Cloud Config `3.0.0-M2`
- Spring Cloud Build `3.0.0-M2`
- Spring Cloud Cloudfoundry `3.0.0-M2`
- Spring Cloud Security `3.0.0-M2`
- Spring Cloud Bus `3.0.0-M2`
- Spring Cloud Cli `3.0.0-M2`
- Spring Cloud Vault `3.0.0-M2`
- Spring Cloud Zookeeper `3.0.0-M2`
- Spring Cloud Commons `3.0.0-M2`
- Spring Cloud Openfeign `3.0.0-M2`
# 2020.0.0-M1
2020-04-16
- Spring Cloud Netflix `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/88?closed=1))
- Spring Cloud Function `3.1.0.M1`
- Spring Cloud Sleuth `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/74?closed=1))
- Spring Cloud Consul `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/47?closed=1))
- Spring Cloud Kubernetes `2.0.0.M1`
- Spring Cloud Gateway `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/36?closed=1))
- Spring Cloud Circuitbreaker `2.0.0.M1`
- Spring Cloud Contract `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/63?closed=1))
- Spring Cloud Starter Build `2020.0.0-M1`
- Spring Cloud Config `3.0.0.M1`
- Spring Cloud Build `3.0.0.M1`
- Spring Cloud Cloudfoundry `3.0.0.M1`
- Spring Cloud Security `3.0.0.M1`
- Spring Cloud Bus `3.0.0.M1`
- Spring Cloud Vault `3.0.0.M1`
- Spring Cloud Zookeeper `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/28?closed=1))
- Spring Cloud Commons `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/72?closed=1))
- Spring Cloud Openfeign `3.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/23?closed=1))
The 2020.0 Release Notes have moved to https://github.com/spring-cloud/spring-cloud-release/wiki/Spring-Cloud-2020.0-Release-Notes

View File

@@ -0,0 +1,67 @@
# 2024.0.0-RC1
2024-11-08
- Spring Cloud Starter Build `2024.0.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-starter-build/releases/tag/v2024.0.0-RC1))
- Spring Cloud Vault `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-vault/releases/tag/v4.2.0-RC1))
- Spring Cloud Stream `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-stream/releases/tag/v4.2.0-RC1))
- Spring Cloud Function `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-function/releases/tag/v4.2.0-RC1))
- Spring Cloud Netflix `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/releases/tag/v4.2.0-RC1))
- Spring Cloud Consul `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-consul/releases/tag/v4.2.0-RC1))
- Spring Cloud Config `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-config/releases/tag/v4.2.0-RC1))
- Spring Cloud Build `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-build/releases/tag/v4.2.0-RC1))
- Spring Cloud Gateway `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/releases/tag/v4.2.0-RC1))
- Spring Cloud Kubernetes `3.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/releases/tag/v3.2.0-RC1))
- Spring Cloud Contract `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-contract/releases/tag/v4.2.0-RC1))
- Spring Cloud Circuitbreaker `3.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/releases/tag/v3.2.0-RC1))
- Spring Cloud Commons `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-commons/releases/tag/v4.2.0-RC1))
- Spring Cloud Openfeign `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/releases/tag/v4.2.0-RC1))
- Spring Cloud Zookeeper `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/releases/tag/v4.2.0-RC1))
- Spring Cloud Bus `4.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-bus/releases/tag/v4.2.0-RC1))
- Spring Cloud Task `3.2.0-RC1` ([issues](https://github.com/spring-cloud/spring-cloud-task/releases/tag/v3.2.0-RC1))
# 2024.0.0-M2
2024-10-08
- Spring Cloud Bus `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-bus/releases/tag/v4.2.0-M2))
- Spring Cloud Contract `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-contract/releases/tag/v4.2.0-M2))
- Spring Cloud Circuitbreaker `3.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/releases/tag/v3.2.0-M2))
- Spring Cloud Zookeeper `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/releases/tag/v4.2.0-M2))
- Spring Cloud Task `3.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-task/releases/tag/v3.2.0-M2))
- Spring Cloud Kubernetes `3.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/releases/tag/v3.2.0-M2))
- Spring Cloud Starter Build `2024.0.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-starter-build/releases/tag/v2024.0.0-M2))
- Spring Cloud Netflix `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/releases/tag/v4.2.0-M2))
- Spring Cloud Openfeign `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/releases/tag/v4.2.0-M2))
- Spring Cloud Commons `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-commons/releases/tag/v4.2.0-M2))
- Spring Cloud Consul `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-consul/releases/tag/v4.2.0-M2))
- Spring Cloud Config `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-config/releases/tag/v4.2.0-M2))
- Spring Cloud Vault `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-vault/releases/tag/v4.2.0-M2))
- Spring Cloud Build `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-build/releases/tag/v4.2.0-M2))
- Spring Cloud Gateway `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/releases/tag/v4.2.0-M2))
- Spring Cloud Stream `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-stream/releases/tag/v4.2.0-M2))
- Spring Cloud Function `4.2.0-M2` ([issues](https://github.com/spring-cloud/spring-cloud-function/releases/tag/v4.2.0-M2))
# 2024.0.0-M1
2024-08-19
- Spring Cloud Bus `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-bus/releases/tag/v4.2.0-M1))
- Spring Cloud Zookeeper `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/releases/tag/v4.2.0-M1))
- Spring Cloud Circuitbreaker `3.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-circuitbreaker/releases/tag/v3.2.0-M1))
- Spring Cloud Task `3.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-task/releases/tag/v3.2.0-M1))
- Spring Cloud Contract `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-contract/releases/tag/v4.2.0-M1))
- Spring Cloud Kubernetes `3.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-kubernetes/releases/tag/v3.2.0-M1))
- Spring Cloud Netflix `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/releases/tag/v4.2.0-M1))
- Spring Cloud Starter Build `2024.0.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-starter-build/releases/tag/v2024.0.0-M1))
- Spring Cloud Config `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-config/releases/tag/v4.2.0-M1))
- Spring Cloud Build `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-build/releases/tag/v4.2.0-M1))
- Spring Cloud Openfeign `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/releases/tag/v4.2.0-M1))
- Spring Cloud Consul `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-consul/releases/tag/v4.2.0-M1))
- Spring Cloud Gateway `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/releases/tag/v4.2.0-M1))
- Spring Cloud Commons `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-commons/releases/tag/v4.2.0-M1))
- Spring Cloud Stream `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-stream/releases/tag/v4.2.0-M1))
- Spring Cloud Function `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-function/releases/tag/v4.2.0-M1))
- Spring Cloud Vault `4.2.0-M1` ([issues](https://github.com/spring-cloud/spring-cloud-vault/releases/tag/v4.2.0-M1))

View File

@@ -1,5 +1,4 @@
Spring Cloud Angel focuses on providing good out of box experience for typical use cases and extensibility mechanism to cover others.
Many of the features are implemented by Netflix OSS, with wrappers for Spring Boot apps being the main focus of Spring Cloud.
Spring Cloud Angel focuses on providing good out of box experience for typical use cases and extensibility mechanism to cover others. Many of the features are implemented by Netflix OSS, with wrappers for Spring Boot apps being the main focus of Spring Cloud.
- Distributed/versioned configuration (git, svn, spring-cloud-config)
- Service registration and discovery (eureka, spring-cloud-netflix)
@@ -12,39 +11,28 @@ Many of the features are implemented by Netflix OSS, with wrappers for Spring Bo
== Main Projects
=== Spring Cloud Config
Centralized external configuration management backed by a git repository.
The configuration resources map directly to Spring `Environment` but could be used by non-Spring applications if desired.
Centralized external configuration management backed by a git repository. The configuration resources map directly to Spring `Environment` but could be used by non-Spring applications if desired.
=== Spring Cloud Netflix
Integration with various Netflix OSS components (Eureka, Hystrix, Zuul, Archaius, etc.).
=== Spring Cloud Bus
An event bus for linking services and service instances together with distributed messaging.
Useful for propagating state changes across a cluster (e.g. config change events).
An event bus for linking services and service instances together with distributed messaging. Useful for propagating state changes across a cluster (e.g. config change events).
=== Spring Cloud Security
Provides support for load-balanced OAuth2 rest client and authentication header relays in a Zuul proxy.
=== Spring Cloud AWS
Easy integration with hosted Amazon Web Services.
It offers a convenient way to interact with AWS provided services using well-known Spring idioms and APIs, such as the messaging or caching API. Developers can build their application around the hosted services without having to care about infrastructure or maintenance.
Easy integration with hosted Amazon Web Services. It offers a convenient way to interact with AWS provided services using well-known Spring idioms and APIs, such as the messaging or caching API. Developers can build their application around the hosted services without having to care about infrastructure or maintenance.
=== Spring Cloud Connectors
Makes it easy for PaaS applications in a variety of platforms to connect to backend services like databases and message brokers (the project formerly known as "Spring Cloud").
Makes it easy for PaaS applications in a variety of platforms to connect to backend services like
databases and message brokers (the project formerly known as "Spring Cloud").
=== Spring Cloud Starters
Spring Boot-style starter projects to ease dependency management for consumers of Spring Cloud.
(Discontinued as a project and merged with the other projects after Angel.SR2.)
Spring Boot-style starter projects to ease dependency management for consumers of Spring Cloud. (Discontinued as a project and merged with the other projects after Angel.SR2.)
=== Spring Cloud CLI
Spring Boot CLI plugin for creating Spring Cloud component applications quickly in Groovy
Spring Cloud Angel builds on Spring Boot 1.2.x, and parts of it (notably the OAuth2 support that moved to Spring Boot) does not work with Spring Boot 1.3.x.

View File

@@ -1,40 +1,28 @@
Spring Cloud Brixton builds on Spring Boot 1.3.x.
It adds the following new projects:
Spring Cloud Brixton builds on Spring Boot 1.3.x. It adds the following new projects:
=== Spring Cloud Zookeeper
Service discovery and configuration management with Apache Zookeeper.
=== Spring Cloud Cloudfoundry
Integrates your application with Pivotal Cloudfoundry.
Provides a service discovery implementation and also makes it easy to implement SSO and OAuth2 protected resources, and also to create a Cloudfoundry service broker.
Integrates your application with Pivotal Cloudfoundry. Provides a service discovery implementation and also makes it easy to implement SSO and OAuth2 protected resources, and also to create a Cloudfoundry service broker.
=== Spring Cloud Cluster
Leadership election and common stateful patterns with an abstraction and implementation for Zookeeper, Redis, Hazelcast, Consul.
(Now deprecated and superseded by Spring Integration.)
Leadership election and common stateful patterns with an abstraction and implementation for Zookeeper, Redis, Hazelcast, Consul. (Now deprecated and superseded by Spring Integration.)
=== Spring Cloud Consul
Service discovery and configuration management with Hashicorp Consul.
=== Spring Cloud Sleuth
Distributed tracing for Spring Cloud applications, compatible with Zipkin, HTrace and log-based (e.g. ELK) tracing.
=== Spring Cloud Stream
Messaging microservices with Redis, Rabbit or Kafka.
Simple declarative model to send and receive messages in a Spring Cloud app.
Messaging microservices with Redis, Rabbit or Kafka. Simple declarative model to send and receive messages in a Spring Cloud app.
=== Spring Cloud Task
Short lived microservices.
Simple declarative for adding both functional and non-functional features to Spring Boot apps.
Short lived microservices. Simple declarative for adding both functional and non-functional features to Spring Boot apps.
=== Spring Cloud Zookeeper
Service discovery and configuration management with Apache Zookeeper.
Spring Cloud Brixton builds with Spring Boot 1.3.x but it should work with 1.4.x as well (we do compatibility tests and hope to be able to fix any issues that crop up).
@@ -47,22 +35,17 @@ Some of the highlights of the Brixton release train are:
* Hashicorp Consul support for service registration/discovery & configuration via Spring Cloud Consul
* Apache Zookeeper support for service registration/discovery, configuration via Spring Cloud Zookeeper and leader election in Spring Cloud Cluster
* Distributed tracing through the Spring Cloud Sleuth abstraction with two out of the box implementations: one supporting logging (ideal for log collectors and multiplexers like Logstash and Loggregator) and one supporting Twitter's Zipkin
* Netflix https://medium.com/netflix-techblog/introducing-atlas-netflixs-primary-telemetry-platform-bd31f4d8ed9a[Atlas Telemetry System], the next generation https://github.com/Netflix/spectator/wiki[Spectator Metrics library] and recent versions of Eureka, Ribbon, Hystrix and Feign are available in Spring Cloud Netflix
* Netflix http://techblog.netflix.com/2014/12/introducing-atlas-netflixs-primary.html[Atlas Telemetry System], the next generation https://github.com/Netflix/spectator/wiki[Spectator Metrics library] and recent versions of Eureka, Ribbon, Hystrix and Feign are available in Spring Cloud Netflix
* Spring Cloud Bus is now powered by the recently released https://spring.io/blog/2016/05/10/spring-cloud-stream-1-0-0-release-is-available[Spring Cloud Stream]
* Cluster Leadership election and locks via Spring Cloud Cluster
* Export of Spring Boot metrics to Amazon Cloudwatch, and native support for Amazon RDS
== Notes:
Starting with Brixton, Zuul will no longer automatically send all headers to downstream services.
By default `Cookie`, `Set-Cookie` and `Authorization` *are not* sent to downstream services.
To return to the Angel behaviour, set `zuul.sensitiveHeaders=""` in the Zuul configuration.
See https://cloud.spring.io/spring-cloud-static/Brixton.SR6/#_cookies_and_sensitive_headers[the documentation] for more information.
Starting with Brixton, Zuul will no longer automatically send all headers to downstream services. By default `Cookie`, `Set-Cookie` and `Authorization` *are not* sent to downstream services. To return to the Angel behaviour, set `zuul.sensitiveHeaders=""` in the Zuul configuration. See http://cloud.spring.io/spring-cloud-static/Brixton.SR6/#_cookies_and_sensitive_headers[the documentation] for more information.
A `@LoadBalanced` `RestTemplate` is no longer created by default.
See the https://cloud.spring.io/spring-cloud-static/spring-cloud.html=_spring_resttemplate_as_a_load_balancer_client[updated documentation for details].
You need to create it in your applications configuration.
For example:
A `@LoadBalanced` `RestTemplate` is no longer created by default. See the http://cloud.spring.io/spring-cloud-static/spring-cloud.html=_spring_resttemplate_as_a_load_balancer_client[updated documentation for details]. You need to create it in your applications configuration. For example:
```java
@Configuration
@@ -80,9 +63,7 @@ Please note the correct BOM to use is `spring-cloud-dependencies` not `spring-cl
=== Migrating Spring Cloud Hystrix, Turbine and Bus with AMQP
The Bus, Hystrix and Turbine support that used to be implemented on top of Spring AMQP have all been migrated to use Spring Cloud Stream.
The old artifacts still exist, but are deprecated and will be removed at some point.
Instead of the `spring-cloud-*-amqp` artifacts you should use whatever raw feature you need, plus a stream binder of your choice, e.g. `spring-cloud-netflix-hystrix-stream` and `spring-cloud-starter-stream-rabbit` instead of `spring-cloud-netflix-hystrix-amqp`.
The Bus, Hystrix and Turbine support that used to be implemented on top of Spring AMQP have all been migrated to use Spring Cloud Stream. The old artifacts still exist, but are deprecated and will be removed at some point. Instead of the `spring-cloud-*-amqp` artifacts you should use whatever raw feature you need, plus a stream binder of your choice, e.g. `spring-cloud-netflix-hystrix-stream` and `spring-cloud-starter-stream-rabbit` instead of `spring-cloud-netflix-hystrix-amqp`.
|===
|Angel | Brixton (with AMQP) | Brixton (with Kafka) |
@@ -111,5 +92,4 @@ NOTE: There is still a `spring-cloud-netflix-hystrix-amqp` in the Brixton releas
- 2016/11/24 - Sleuth version `1.0.11.RELEASE` https://github.com/spring-cloud/spring-cloud-sleuth/milestone/17?closed=1[(issues)]
- 2016/11/23 - Config version `1.1.3.RELEASE` https://github.com/spring-cloud/spring-cloud-config/milestone/21?closed=1[(issues)]
Note:
There was an XXE vulnerability in xstream (which is used by Eureka), so please upgrade to Brixton.SR7 to pull in the latest version of that library which fixed the issue (https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2016-3674).
Note: There was an XXE vulnerability in xstream (which is used by Eureka), so please upgrade to Brixton.SR7 to pull in the latest version of that library which fixed the issue (https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2016-3674).

View File

@@ -19,6 +19,35 @@ A number of starters did not follow normal Spring Cloud naming conventions. In E
| spring-cloud-starter-turbine-stream | spring-cloud-starter-netflix-turbine-stream |
| spring-cloud-starter-zuul | spring-cloud-starter-netflix-zuul |
# Edgware.SR6
2019-05-23
- Spring Cloud Starter `Edgware.SR6`
- Spring Cloud Release `Edgware.SR6`
- Spring Cloud Security `1.2.4.RELEASE`
- Spring Cloud Bus `1.3.5.RELEASE`
- Spring Cloud Stream `Ditmars.SR5`
- Spring Cloud Task `1.2.4.RELEASE`
- Spring Cloud Netflix `1.4.7.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/issues?q=is%3Aclosed+milestone%3A1.4.7.RELEASE))
- Spring Cloud Sleuth `1.3.6.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/issues?q=is%3Aclosed+milestone%3A1.3.6.RELEASE))
- Spring Cloud Config `1.4.7.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/56?closed=1))
- Spring Cloud `Edgware.SR6`
- Spring Cloud Dependencies `Edgware.SR6`
- Spring Cloud Commons `1.3.6.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/56?closed=1))
- Spring Cloud Build `1.3.13.RELEASE`
- Spring Cloud Vault `1.1.3.RELEASE` (upgraded to Vault 1.1.3)
- Spring Cloud Zookeeper `1.2.3.RELEASE`
- Spring Cloud Contract `1.2.7.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-contract/issues?q=is%3Aclosed+milestone%3A1.2.7.RELEASE))
- Spring Cloud Aws `1.2.4.RELEASE`
- Spring Cloud Consul `1.3.6.RELEASE`
- Spring Cloud Cloudfoundry `1.1.3.RELEASE`
- Spring Cloud Function `1.0.2.RELEASE`
- Spring Cloud Gateway `1.0.3.RELEASE`
# Edgware.SR5
2018-10-16
@@ -145,4 +174,3 @@ A number of starters did not follow normal Spring Cloud naming conventions. In E
- Spring Cloud Vault `1.1.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/5?closed=1))
- Spring Cloud Gateway `1.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/2?closed=1))

View File

@@ -1,5 +1,65 @@
Spring Cloud Finchley builds on Spring Boot 2.0.x and is not compatible with 1.x.y.
# Finchley.SR4
2019-06-08
- Spring Cloud Commons `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/60?closed=1))
- Spring Cloud Openfeign `2.0.4.RELEASE`
- Spring Cloud Dependencies `Finchley.SR4`
- Spring Cloud Release `Finchley.SR4`
- Spring Cloud Starter `Finchley.SR4`
- Spring Cloud Stream `Elmhurst.SR3`
- Spring Cloud Cloudfoundry `2.0.2.RELEASE`
- Spring Cloud Task `2.0.2.RELEASE`
- Spring Cloud Build `2.0.6.RELEASE`
- Spring Cloud Vault `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/32?closed=1))
- Spring Cloud Zookeeper `2.0.2.RELEASE`
- Spring Cloud Config `2.0.5.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/65?closed=1))
- Spring Cloud Aws `2.0.3.RELEASE`
- Spring Cloud Bus `2.0.2.RELEASE`
- Spring Cloud `Finchley.SR4`
- Spring Cloud Security `2.0.2.RELEASE`
- Spring Cloud Gateway `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/23?closed=1))
- Spring Cloud Netflix `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/78?closed=1))
- Spring Cloud Sleuth `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/61?closed=1))
- Spring Cloud Consul `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/36?closed=1))
- Spring Cloud Contract `2.0.4.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/52?closed=1))
- Spring Cloud Function `1.0.2.RELEASE`
# Finchley.SR3
2019-02-22
- Spring Cloud Config `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-config/milestone/57?closed=1))
- Spring Cloud Function `1.0.0.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-function/milestone/7?closed=1))
- Spring Cloud Starter `Finchley.SR3`
- Spring Cloud Release `Finchley.SR3`
- Spring Cloud Stream `Elmhurst.SR2`
- Spring Cloud Sleuth `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-sleuth/milestone/60?closed=1))
- Spring Cloud Cloudfoundry `2.0.1.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-cloudfoundry/milestone/10?closed=1))
- Spring Cloud Zookeeper `2.0.1.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-zookeeper/milestone/25?closed=1))
- Spring Cloud Aws `2.0.2.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-aws/milestone/25?closed=1))
- Spring Cloud Task `2.0.1.RELEASE`
- Spring Cloud Commons `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/55?closed=1))
- Spring Cloud Build `2.0.5.RELEASE`
- Spring Cloud Openfeign `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-openfeign/milestone/8?closed=1))
- Spring Cloud Vault `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/26?closed=1))
- Spring Cloud `Finchley.SR3`
- Spring Cloud Security `2.0.1.RELEASE`
- Spring Cloud Bus `2.0.1.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-bus/milestone/33?closed=1))
- Spring Cloud Contract `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-contract/milestone/44?closed=1))
- Spring Cloud Consul `2.0.2.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-consul/milestone/36?closed=1))
- Spring Cloud Gateway `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-gateway/milestone/19?closed=1))
- Spring Cloud Dependencies `Finchley.SR3`
- Spring Cloud Netflix `2.0.3.RELEASE` ([issues](https://github.com/spring-cloud/spring-cloud-netflix/milestone/72?closed=1))
# Finchley.SR2
2018-10-23
@@ -213,4 +273,4 @@ Spring Cloud Finchley builds on Spring Boot 2.0.x and is not compatible with 1.x
- Spring Cloud Task `2.0.0.M1` ([issues](https://github.com/spring-cloud/spring-cloud-task/milestone/18?closed=1))
- Spring Cloud Vault `2.0.0.M3` ([issues](https://github.com/spring-cloud/spring-cloud-vault/milestone/11?closed=1))
- Spring Cloud Zookeeper `2.0.0.M2`
- Spring Cloud Commons `2.0.0.M3` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/34?closed=1))
- Spring Cloud Commons `2.0.0.M3` ([issues](https://github.com/spring-cloud/spring-cloud-commons/milestone/34?closed=1))

View File

@@ -0,0 +1 @@
The Hoxton Release Notes have moved to https://github.com/spring-cloud/spring-cloud-release/wiki/Spring-Cloud-Hoxton-Release-Notes

View File

@@ -3,3 +3,5 @@
| Athens | 1.4.x | Camden |
| Brussels | 1.5.x | Dalston & Edgware |
| Cairo | 2.0.x | Finchley |
The Spring IO Platform has been discontinued in favor of Spring Boot.

View File

@@ -1 +1 @@
adding Spring Clouud 2020.0 release notes
Remove Greenwich release notes.

View File

@@ -3,8 +3,6 @@
filemode = true
bare = false
logallrefupdates = true
ignorecase = true
precomposeunicode = true
[remote "origin"]
url = git@github.com:spring-projects/spring-cloud.wiki.git
fetch = +refs/heads/*:refs/remotes/origin/*

View File

@@ -18,7 +18,7 @@
# This example catches duplicate Signed-off-by lines.
test "" = "$(grep '^Signed-off-by: ' "$1" |
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
sort | uniq -c | sed -e '/^[ ]*1[ ]/d')" || {
echo >&2 Duplicate Signed-off-by lines.
exit 1
}

View File

@@ -0,0 +1,174 @@
#!/usr/bin/perl
use strict;
use warnings;
use IPC::Open2;
# An example hook script to integrate Watchman
# (https://facebook.github.io/watchman/) with git to speed up detecting
# new and modified files.
#
# The hook is passed a version (currently 2) and last update token
# formatted as a string and outputs to stdout a new update token and
# all files that have been modified since the update token. Paths must
# be relative to the root of the working tree and separated by a single NUL.
#
# To enable this hook, rename this file to "query-watchman" and set
# 'git config core.fsmonitor .git/hooks/query-watchman'
#
my ($version, $last_update_token) = @ARGV;
# Uncomment for debugging
# print STDERR "$0 $version $last_update_token\n";
# Check the hook interface version
if ($version ne 2) {
die "Unsupported query-fsmonitor hook version '$version'.\n" .
"Falling back to scanning...\n";
}
my $git_work_tree = get_working_dir();
my $retry = 1;
my $json_pkg;
eval {
require JSON::XS;
$json_pkg = "JSON::XS";
1;
} or do {
require JSON::PP;
$json_pkg = "JSON::PP";
};
launch_watchman();
sub launch_watchman {
my $o = watchman_query();
if (is_work_tree_watched($o)) {
output_result($o->{clock}, @{$o->{files}});
}
}
sub output_result {
my ($clockid, @files) = @_;
# Uncomment for debugging watchman output
# open (my $fh, ">", ".git/watchman-output.out");
# binmode $fh, ":utf8";
# print $fh "$clockid\n@files\n";
# close $fh;
binmode STDOUT, ":utf8";
print $clockid;
print "\0";
local $, = "\0";
print @files;
}
sub watchman_clock {
my $response = qx/watchman clock "$git_work_tree"/;
die "Failed to get clock id on '$git_work_tree'.\n" .
"Falling back to scanning...\n" if $? != 0;
return $json_pkg->new->utf8->decode($response);
}
sub watchman_query {
my $pid = open2(\*CHLD_OUT, \*CHLD_IN, 'watchman -j --no-pretty')
or die "open2() failed: $!\n" .
"Falling back to scanning...\n";
# In the query expression below we're asking for names of files that
# changed since $last_update_token but not from the .git folder.
#
# To accomplish this, we're using the "since" generator to use the
# recency index to select candidate nodes and "fields" to limit the
# output to file names only. Then we're using the "expression" term to
# further constrain the results.
my $last_update_line = "";
if (substr($last_update_token, 0, 1) eq "c") {
$last_update_token = "\"$last_update_token\"";
$last_update_line = qq[\n"since": $last_update_token,];
}
my $query = <<" END";
["query", "$git_work_tree", {$last_update_line
"fields": ["name"],
"expression": ["not", ["dirname", ".git"]]
}]
END
# Uncomment for debugging the watchman query
# open (my $fh, ">", ".git/watchman-query.json");
# print $fh $query;
# close $fh;
print CHLD_IN $query;
close CHLD_IN;
my $response = do {local $/; <CHLD_OUT>};
# Uncomment for debugging the watch response
# open ($fh, ">", ".git/watchman-response.json");
# print $fh $response;
# close $fh;
die "Watchman: command returned no output.\n" .
"Falling back to scanning...\n" if $response eq "";
die "Watchman: command returned invalid output: $response\n" .
"Falling back to scanning...\n" unless $response =~ /^\{/;
return $json_pkg->new->utf8->decode($response);
}
sub is_work_tree_watched {
my ($output) = @_;
my $error = $output->{error};
if ($retry > 0 and $error and $error =~ m/unable to resolve root .* directory (.*) is not watched/) {
$retry--;
my $response = qx/watchman watch "$git_work_tree"/;
die "Failed to make watchman watch '$git_work_tree'.\n" .
"Falling back to scanning...\n" if $? != 0;
$output = $json_pkg->new->utf8->decode($response);
$error = $output->{error};
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
# Uncomment for debugging watchman output
# open (my $fh, ">", ".git/watchman-output.out");
# close $fh;
# Watchman will always return all files on the first query so
# return the fast "everything is dirty" flag to git and do the
# Watchman query just to get it over with now so we won't pay
# the cost in git to look up each individual file.
my $o = watchman_clock();
$error = $output->{error};
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
output_result($o->{clock}, ("/"));
$last_update_token = $o->{clock};
eval { launch_watchman() };
return 0;
}
die "Watchman: $error.\n" .
"Falling back to scanning...\n" if $error;
return 1;
}
sub get_working_dir {
my $working_dir;
if ($^O =~ 'msys' || $^O =~ 'cygwin') {
$working_dir = Win32::GetCwd();
$working_dir =~ tr/\\/\//;
} else {
require Cwd;
$working_dir = Cwd::cwd();
}
return $working_dir;
}

View File

@@ -7,15 +7,16 @@
#
# To enable this hook, rename this file to "pre-commit".
if git rev-parse --verify HEAD >/dev/null 2>&1; then
against=HEAD
if git rev-parse --verify HEAD >/dev/null 2>&1
then
against=HEAD
else
# Initial commit: diff against an empty tree object
against=4b825dc642cb6eb9a060e54bf8d69288fbee4904
# Initial commit: diff against an empty tree object
against=$(git hash-object -t tree /dev/null)
fi
# If you want to allow non-ASCII filenames set this variable to true.
allownonascii=$(git config --bool hooks.allownonascii)
allownonascii=$(git config --type=bool hooks.allownonascii)
# Redirect output to stderr.
exec 1>&2
@@ -24,12 +25,13 @@ exec 1>&2
# them from being added to the repository. We exploit the fact that the
# printable range starts at the space character and ends with tilde.
if [ "$allownonascii" != "true" ] &&
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0; then
cat <<\EOF
# Note that the use of brackets around a tr range is ok here, (it's
# even required, for portability to Solaris 10's /usr/bin/tr), since
# the square bracket bytes happen to fall in the designated range.
test $(git diff --cached --name-only --diff-filter=A -z $against |
LC_ALL=C tr -d '[ -~]\0' | wc -c) != 0
then
cat <<\EOF
Error: Attempt to add a non-ASCII file name.
This can cause problems if you want to work with people on other platforms.
@@ -40,7 +42,7 @@ If you know what you are doing you can disable this check using:
git config hooks.allownonascii true
EOF
exit 1
exit 1
fi
# If there are whitespace errors, print the offending file names and fail.

View File

@@ -0,0 +1,13 @@
#!/bin/sh
#
# An example hook script to verify what is about to be committed.
# Called by "git merge" with no arguments. The hook should
# exit with non-zero status after issuing an appropriate message to
# stderr if it wants to stop the merge commit.
#
# To enable this hook, rename this file to "pre-merge-commit".
. git-sh-setup
test -x "$GIT_DIR/hooks/pre-commit" &&
exec "$GIT_DIR/hooks/pre-commit"
:

View File

@@ -14,7 +14,7 @@
# Information about the commits which are being pushed is supplied as lines to
# the standard input in the form:
#
# <local ref> <local sha1> <remote ref> <remote sha1>
# <local ref> <local oid> <remote ref> <remote oid>
#
# This sample shows how to prevent push of commits where the log message starts
# with "WIP" (work in progress).
@@ -22,28 +22,32 @@
remote="$1"
url="$2"
z40=0000000000000000000000000000000000000000
zero=$(git hash-object --stdin </dev/null | tr '[0-9a-f]' '0')
while read local_ref local_sha remote_ref remote_sha; do
if [ "$local_sha" = $z40 ]; then
# Handle delete
:
else
if [ "$remote_sha" = $z40 ]; then
# New branch, examine all commits
range="$local_sha"
else
# Update to existing branch, examine new commits
range="$remote_sha..$local_sha"
fi
while read local_ref local_oid remote_ref remote_oid
do
if test "$local_oid" = "$zero"
then
# Handle delete
:
else
if test "$remote_oid" = "$zero"
then
# New branch, examine all commits
range="$local_oid"
else
# Update to existing branch, examine new commits
range="$remote_oid..$local_oid"
fi
# Check for WIP commit
commit=$(git rev-list -n 1 --grep '^WIP' "$range")
if [ -n "$commit" ]; then
echo >&2 "Found WIP commit in $local_ref, not pushing"
exit 1
fi
fi
# Check for WIP commit
commit=$(git rev-list -n 1 --grep '^WIP' "$range")
if test -n "$commit"
then
echo >&2 "Found WIP commit in $local_ref, not pushing"
exit 1
fi
fi
done
exit 0

View File

@@ -17,19 +17,20 @@
publish=next
basebranch="$1"
if test "$#" = 2; then
topic="refs/heads/$2"
if test "$#" = 2
then
topic="refs/heads/$2"
else
topic=$(git symbolic-ref HEAD) ||
exit 0 # we do not interrupt rebasing detached HEAD
topic=`git symbolic-ref HEAD` ||
exit 0 ;# we do not interrupt rebasing detached HEAD
fi
case "$topic" in
refs/heads/??/*) ;;
refs/heads/??/*)
;;
*)
exit 0 # we do not interrupt others.
;;
exit 0 ;# we do not interrupt others.
;;
esac
# Now we are dealing with a topic branch being rebased
@@ -37,31 +38,34 @@ esac
# Does the topic really exist?
git show-ref -q "$topic" || {
echo >&2 "No such branch $topic"
exit 1
echo >&2 "No such branch $topic"
exit 1
}
# Is topic fully merged to master?
not_in_master=$(git rev-list --pretty=oneline ^master "$topic")
if test -z "$not_in_master"; then
echo >&2 "$topic is fully merged to master; better remove it."
exit 1 # we could allow it, but there is no point.
not_in_master=`git rev-list --pretty=oneline ^master "$topic"`
if test -z "$not_in_master"
then
echo >&2 "$topic is fully merged to master; better remove it."
exit 1 ;# we could allow it, but there is no point.
fi
# Is topic ever merged to next? If so you should not be rebasing it.
only_next_1=$(git rev-list ^master "^$topic" ${publish} | sort)
only_next_2=$(git rev-list ^master ${publish} | sort)
if test "$only_next_1" = "$only_next_2"; then
not_in_topic=$(git rev-list "^$topic" master)
if test -z "$not_in_topic"; then
echo >&2 "$topic is already up to date with master"
exit 1 # we could allow it, but there is no point.
else
exit 0
fi
only_next_1=`git rev-list ^master "^$topic" ${publish} | sort`
only_next_2=`git rev-list ^master ${publish} | sort`
if test "$only_next_1" = "$only_next_2"
then
not_in_topic=`git rev-list "^$topic" master`
if test -z "$not_in_topic"
then
echo >&2 "$topic is already up to date with master"
exit 1 ;# we could allow it, but there is no point.
else
exit 0
fi
else
not_in_next=$(git rev-list --pretty=oneline ^${publish} "$topic")
/usr/bin/perl -e '
not_in_next=`git rev-list --pretty=oneline ^${publish} "$topic"`
/usr/bin/perl -e '
my $topic = $ARGV[0];
my $msg = "* $topic has commits already merged to public branch:\n";
my (%not_in_next) = map {
@@ -81,7 +85,7 @@ else
}
}
' "$topic" "$not_in_next" "$not_in_master"
exit 1
exit 1
fi
<<\DOC_END

View File

@@ -6,18 +6,19 @@
#
# To enable this hook, rename this file to "pre-receive".
if test -n "$GIT_PUSH_OPTION_COUNT"; then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"; do
eval "value=\$GIT_PUSH_OPTION_$i"
case "$value" in
echoback=*)
echo "echo from the pre-receive-hook: ${value#*=}" >&2
;;
reject)
exit 1
;;
esac
i=$((i + 1))
done
if test -n "$GIT_PUSH_OPTION_COUNT"
then
i=0
while test "$i" -lt "$GIT_PUSH_OPTION_COUNT"
do
eval "value=\$GIT_PUSH_OPTION_$i"
case "$value" in
echoback=*)
echo "echo from the pre-receive-hook: ${value#*=}" >&2
;;
reject)
exit 1
esac
i=$((i + 1))
done
fi

View File

@@ -0,0 +1,78 @@
#!/bin/sh
# An example hook script to update a checked-out tree on a git push.
#
# This hook is invoked by git-receive-pack(1) when it reacts to git
# push and updates reference(s) in its repository, and when the push
# tries to update the branch that is currently checked out and the
# receive.denyCurrentBranch configuration variable is set to
# updateInstead.
#
# By default, such a push is refused if the working tree and the index
# of the remote repository has any difference from the currently
# checked out commit; when both the working tree and the index match
# the current commit, they are updated to match the newly pushed tip
# of the branch. This hook is to be used to override the default
# behaviour; however the code below reimplements the default behaviour
# as a starting point for convenient modification.
#
# The hook receives the commit with which the tip of the current
# branch is going to be updated:
commit=$1
# It can exit with a non-zero status to refuse the push (when it does
# so, it must not modify the index or the working tree).
die () {
echo >&2 "$*"
exit 1
}
# Or it can make any necessary changes to the working tree and to the
# index to bring them to the desired state when the tip of the current
# branch is updated to the new commit, and exit with a zero status.
#
# For example, the hook can simply run git read-tree -u -m HEAD "$1"
# in order to emulate git fetch that is run in the reverse direction
# with git push, as the two-tree form of git read-tree -u -m is
# essentially the same as git switch or git checkout that switches
# branches while keeping the local changes in the working tree that do
# not interfere with the difference between the branches.
# The below is a more-or-less exact translation to shell of the C code
# for the default behaviour for git's push-to-checkout hook defined in
# the push_to_deploy() function in builtin/receive-pack.c.
#
# Note that the hook will be executed from the repository directory,
# not from the working tree, so if you want to perform operations on
# the working tree, you will have to adapt your code accordingly, e.g.
# by adding "cd .." or using relative paths.
if ! git update-index -q --ignore-submodules --refresh
then
die "Up-to-date check failed"
fi
if ! git diff-files --quiet --ignore-submodules --
then
die "Working directory has unstaged changes"
fi
# This is a rough translation of:
#
# head_has_history() ? "HEAD" : EMPTY_TREE_SHA1_HEX
if git cat-file -e HEAD 2>/dev/null
then
head=HEAD
else
head=$(git hash-object -t tree --stdin </dev/null)
fi
if ! git diff-index --quiet --cached --ignore-submodules $head --
then
die "Working directory has staged changes"
fi
if ! git read-tree -u -m "$commit"
then
die "Could not update working tree to new HEAD"
fi

View File

@@ -0,0 +1,77 @@
#!/bin/sh
# An example hook script to validate a patch (and/or patch series) before
# sending it via email.
#
# The hook should exit with non-zero status after issuing an appropriate
# message if it wants to prevent the email(s) from being sent.
#
# To enable this hook, rename this file to "sendemail-validate".
#
# By default, it will only check that the patch(es) can be applied on top of
# the default upstream branch without conflicts in a secondary worktree. After
# validation (successful or not) of the last patch of a series, the worktree
# will be deleted.
#
# The following config variables can be set to change the default remote and
# remote ref that are used to apply the patches against:
#
# sendemail.validateRemote (default: origin)
# sendemail.validateRemoteRef (default: HEAD)
#
# Replace the TODO placeholders with appropriate checks according to your
# needs.
validate_cover_letter () {
file="$1"
# TODO: Replace with appropriate checks (e.g. spell checking).
true
}
validate_patch () {
file="$1"
# Ensure that the patch applies without conflicts.
git am -3 "$file" || return
# TODO: Replace with appropriate checks for this patch
# (e.g. checkpatch.pl).
true
}
validate_series () {
# TODO: Replace with appropriate checks for the whole series
# (e.g. quick build, coding style checks, etc.).
true
}
# main -------------------------------------------------------------------------
if test "$GIT_SENDEMAIL_FILE_COUNTER" = 1
then
remote=$(git config --default origin --get sendemail.validateRemote) &&
ref=$(git config --default HEAD --get sendemail.validateRemoteRef) &&
worktree=$(mktemp --tmpdir -d sendemail-validate.XXXXXXX) &&
git worktree add -fd --checkout "$worktree" "refs/remotes/$remote/$ref" &&
git config --replace-all sendemail.validateWorktree "$worktree"
else
worktree=$(git config --get sendemail.validateWorktree)
fi || {
echo "sendemail-validate: error: failed to prepare worktree" >&2
exit 1
}
unset GIT_DIR GIT_WORK_TREE
cd "$worktree" &&
if grep -q "^diff --git " "$1"
then
validate_patch "$1"
else
validate_cover_letter "$1"
fi &&
if test "$GIT_SENDEMAIL_FILE_COUNTER" = "$GIT_SENDEMAIL_FILE_TOTAL"
then
git config --unset-all sendemail.validateWorktree &&
trap 'git worktree remove -ff "$worktree"' EXIT &&
validate_series
fi

View File

@@ -31,96 +31,97 @@ newrev="$3"
# --- Safety check
if [ -z "$GIT_DIR" ]; then
echo "Don't run this script from the command line." >&2
echo " (if you want, you could supply GIT_DIR then run" >&2
echo " $0 <ref> <oldrev> <newrev>)" >&2
exit 1
echo "Don't run this script from the command line." >&2
echo " (if you want, you could supply GIT_DIR then run" >&2
echo " $0 <ref> <oldrev> <newrev>)" >&2
exit 1
fi
if [ -z "$refname" -o -z "$oldrev" -o -z "$newrev" ]; then
echo "usage: $0 <ref> <oldrev> <newrev>" >&2
exit 1
echo "usage: $0 <ref> <oldrev> <newrev>" >&2
exit 1
fi
# --- Config
allowunannotated=$(git config --bool hooks.allowunannotated)
allowdeletebranch=$(git config --bool hooks.allowdeletebranch)
denycreatebranch=$(git config --bool hooks.denycreatebranch)
allowdeletetag=$(git config --bool hooks.allowdeletetag)
allowmodifytag=$(git config --bool hooks.allowmodifytag)
allowunannotated=$(git config --type=bool hooks.allowunannotated)
allowdeletebranch=$(git config --type=bool hooks.allowdeletebranch)
denycreatebranch=$(git config --type=bool hooks.denycreatebranch)
allowdeletetag=$(git config --type=bool hooks.allowdeletetag)
allowmodifytag=$(git config --type=bool hooks.allowmodifytag)
# check for no description
projectdesc=$(sed -e '1q' "$GIT_DIR/description")
case "$projectdesc" in
"Unnamed repository"* | "")
echo "*** Project description file hasn't been set" >&2
exit 1
;;
echo "*** Project description file hasn't been set" >&2
exit 1
;;
esac
# --- Check types
# if $newrev is 0000...0000, it's a commit to delete a ref.
zero="0000000000000000000000000000000000000000"
zero=$(git hash-object --stdin </dev/null | tr '[0-9a-f]' '0')
if [ "$newrev" = "$zero" ]; then
newrev_type=delete
newrev_type=delete
else
newrev_type=$(git cat-file -t $newrev)
newrev_type=$(git cat-file -t $newrev)
fi
case "$refname","$newrev_type" in
refs/tags/*,commit)
# un-annotated tag
short_refname=${refname##refs/tags/}
if [ "$allowunannotated" != "true" ]; then
echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
exit 1
fi
;;
refs/tags/*,delete)
# delete tag
if [ "$allowdeletetag" != "true" ]; then
echo "*** Deleting a tag is not allowed in this repository" >&2
exit 1
fi
;;
refs/tags/*,tag)
# annotated tag
if [ "$allowmodifytag" != "true" ] && git rev-parse $refname >/dev/null 2>&1; then
echo "*** Tag '$refname' already exists." >&2
echo "*** Modifying a tag is not allowed in this repository." >&2
exit 1
fi
;;
refs/heads/*,commit)
# branch
if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
echo "*** Creating a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/heads/*,delete)
# delete branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/remotes/*,commit)
# tracking branch
;;
refs/remotes/*,delete)
# delete tracking branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a tracking branch is not allowed in this repository" >&2
exit 1
fi
;;
*)
# Anything else (is there anything else?)
echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
exit 1
;;
refs/tags/*,commit)
# un-annotated tag
short_refname=${refname##refs/tags/}
if [ "$allowunannotated" != "true" ]; then
echo "*** The un-annotated tag, $short_refname, is not allowed in this repository" >&2
echo "*** Use 'git tag [ -a | -s ]' for tags you want to propagate." >&2
exit 1
fi
;;
refs/tags/*,delete)
# delete tag
if [ "$allowdeletetag" != "true" ]; then
echo "*** Deleting a tag is not allowed in this repository" >&2
exit 1
fi
;;
refs/tags/*,tag)
# annotated tag
if [ "$allowmodifytag" != "true" ] && git rev-parse $refname > /dev/null 2>&1
then
echo "*** Tag '$refname' already exists." >&2
echo "*** Modifying a tag is not allowed in this repository." >&2
exit 1
fi
;;
refs/heads/*,commit)
# branch
if [ "$oldrev" = "$zero" -a "$denycreatebranch" = "true" ]; then
echo "*** Creating a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/heads/*,delete)
# delete branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a branch is not allowed in this repository" >&2
exit 1
fi
;;
refs/remotes/*,commit)
# tracking branch
;;
refs/remotes/*,delete)
# delete tracking branch
if [ "$allowdeletebranch" != "true" ]; then
echo "*** Deleting a tracking branch is not allowed in this repository" >&2
exit 1
fi
;;
*)
# Anything else (is there anything else?)
echo "*** Update hook: unknown type of update to ref $refname of type $newrev_type" >&2
exit 1
;;
esac
# --- Finished

View File

@@ -1,2 +1,3 @@
0000000000000000000000000000000000000000 3fa536308bcdaf5c4670c0c438ead6b3cad990da Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1540806486 +0100 clone: from git@github.com:spring-projects/spring-cloud.wiki.git
3fa536308bcdaf5c4670c0c438ead6b3cad990da 1fa2c37fe634da1c5e640dcb461711d356f660f2 Ryan Baxter <rbaxter@vmware.com> 1639686770 -0500 commit: adding Spring Clouud 2020.0 release notes
0000000000000000000000000000000000000000 1785af439856701b2358e12b0e48ccb83b112a4e Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733231305 +0100 clone: from github.com:spring-projects/spring-cloud.wiki.git
1785af439856701b2358e12b0e48ccb83b112a4e dd50b467f8f23bb630707e5769cce5cd7897d0a7 Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733231592 +0100 commit: Add Spring-Cloud-2024.0-Release-Notes.md.
dd50b467f8f23bb630707e5769cce5cd7897d0a7 1041a98675ba038b74202fd7560baf1b6f918d19 Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733240359 +0100 commit: Remove Greenwich release notes.

View File

@@ -1,2 +1,3 @@
0000000000000000000000000000000000000000 3fa536308bcdaf5c4670c0c438ead6b3cad990da Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1540806486 +0100 clone: from git@github.com:spring-projects/spring-cloud.wiki.git
3fa536308bcdaf5c4670c0c438ead6b3cad990da 1fa2c37fe634da1c5e640dcb461711d356f660f2 Ryan Baxter <rbaxter@vmware.com> 1639686770 -0500 commit: adding Spring Clouud 2020.0 release notes
0000000000000000000000000000000000000000 1785af439856701b2358e12b0e48ccb83b112a4e Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733231305 +0100 clone: from github.com:spring-projects/spring-cloud.wiki.git
1785af439856701b2358e12b0e48ccb83b112a4e dd50b467f8f23bb630707e5769cce5cd7897d0a7 Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733231592 +0100 commit: Add Spring-Cloud-2024.0-Release-Notes.md.
dd50b467f8f23bb630707e5769cce5cd7897d0a7 1041a98675ba038b74202fd7560baf1b6f918d19 Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733240359 +0100 commit: Remove Greenwich release notes.

View File

@@ -1 +1 @@
0000000000000000000000000000000000000000 3fa536308bcdaf5c4670c0c438ead6b3cad990da Marcin Grzejszczak <mgrzejszczak@pivotal.io> 1540806486 +0100 clone: from git@github.com:spring-projects/spring-cloud.wiki.git
0000000000000000000000000000000000000000 1785af439856701b2358e12b0e48ccb83b112a4e Olga Maciaszek-Sharma <omaciaszeksh@vmware.com> 1733231305 +0100 clone: from github.com:spring-projects/spring-cloud.wiki.git

View File

@@ -1 +0,0 @@
x<01><>kN1 <0C><><EFBFBD>S<EFBFBD>TnN"!<21><>p<02>q<EFBFBD>RwS<77>Y<1E>g<EFBFBD>

View File

@@ -1,2 +1,2 @@
# pack-refs with: peeled fully-peeled sorted
3fa536308bcdaf5c4670c0c438ead6b3cad990da refs/remotes/origin/master
1785af439856701b2358e12b0e48ccb83b112a4e refs/remotes/origin/master

View File

@@ -1 +1 @@
1fa2c37fe634da1c5e640dcb461711d356f660f2
1041a98675ba038b74202fd7560baf1b6f918d19